-- name: [CS] Kwi
-- description: Kee Wee \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_KWI_MODEL = smlua_model_util_get_id("kwi_geo")
local E_MODEL_KWI2_MODEL = smlua_model_util_get_id("kwi2_geo")
local E_MODEL_KIWARIO_MODEL = smlua_model_util_get_id("kiwario_geo")

local TEX_KWI_ICON = get_texture_info("kwi-icon")

local TEXT_MOD_NAME = "[CS] KWI"

local VOICETABLE_KWI = {
    [CHAR_SOUND_ATTACKED] = 'kiwi.ogg',
	[CHAR_SOUND_COUGHING1] = 'kiwi.ogg',
    [CHAR_SOUND_COUGHING2] = 'kiwi.ogg',
    [CHAR_SOUND_COUGHING3] = 'kiwi.ogg',
	[CHAR_SOUND_EEUH] = 'kiwi.ogg',
    [CHAR_SOUND_HRMM] = 'kiwi.ogg',
    [CHAR_SOUND_PANTING] = 'kiwi.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'kiwi.ogg',
    [CHAR_SOUND_DOH] = 'kiwi.ogg',
    [CHAR_SOUND_DROWNING] = 'death.ogg',
    [CHAR_SOUND_DYING] = 'death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'kiwi.ogg',
    [CHAR_SOUND_HAHA] = 'kiwi.ogg',
    [CHAR_SOUND_HAHA_2] = 'kiwi.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'kiwi.ogg',
    [CHAR_SOUND_HOOHOO] = 'kiwi.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'kiwi.ogg',
    [CHAR_SOUND_ON_FIRE] = 'falling.ogg',
    [CHAR_SOUND_OOOF] = 'kiwi.ogg',
    [CHAR_SOUND_OOOF2] = 'kiwi.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'kwi.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'kiwi.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'kiwi.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'kiwi.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'death.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'kiwi.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'falling.ogg',
    [CHAR_SOUND_WAH2] = 'kiwi.ogg',
    [CHAR_SOUND_WHOA] = 'kiwi.ogg',
    [CHAR_SOUND_YAHOO] = 'kiwi.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'kiwi.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'kiwi.ogg',
}

if _G.charSelectExists then
    CT_KWI = _G.charSelect.character_add("Kwi", {"The Playstation can produce", "mind-Boggling effects", "", "", "Use D-pad L/R to Switch Skins"}, "Marcel T.", {r = 17, g = 153, b = 19}, E_MODEL_KWI_MODEL, CT_MARIO, TEX_KWI_ICON)

    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_KWI_MODEL, VOICETABLE_KWI)
    _G.charSelect.character_add_voice(E_MODEL_KWI2_MODEL, VOICETABLE_KWI)
    _G.charSelect.character_add_voice(E_MODEL_KIWARIO_MODEL, VOICETABLE_KWI)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_KWI then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_KWI then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end

local kwiAlt = 1
local kwiAltTable = {
    {outfitName = "Kiwi", outfitModel = E_MODEL_KWI_MODEL},
	{outfitName = "Red Kiwi", outfitModel = E_MODEL_KWI2_MODEL},
    {outfitName = "KiWario", outfitModel = E_MODEL_KIWARIO_MODEL},
}

--[[
for i = 1, kwiAltTable do
    _G.charSelect.character_add_voice(kwiAltTable[i].outfitModel, VOICETABLE_KWI)
end
]]

local function update_kwi_edit(intAdd)
    kwiAlt = kwiAlt + intAdd
    if kwiAlt > #kwiAltTable then kwiAlt = 1 end
    if kwiAlt < 1 then kwiAlt = #kwiAltTable end
    _G.charSelect.character_edit(CT_KWI, nil, {"The Playstation can produce", "mind-Boggling effects", "", "< Skin: "..kwiAltTable[kwiAlt].outfitName.." >", "Use D-pad L/R to Switch Skins"}, nil, nil, kwiAltTable[kwiAlt].outfitModel, CT_KWI, TEX_KWI_ICON, 1)
end

local function mario_update(m)
    if m.playerIndex ~= 0 then return end
    if _G.charSelect.is_menu_open() then
        if _G.charSelect.character_get_current_number() == CT_KWI then
            if (_G.charSelect.controller.buttonPressed & R_JPAD) ~= 0 then
                update_kwi_edit(1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
            if (_G.charSelect.controller.buttonPressed & L_JPAD) ~= 0 then
                update_kwi_edit(-1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
        end
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)